package com.qmth.eds.common.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.eds.core.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Objects;

/**
 * <p>
 * 学院
 * </p>
 */
@ApiModel(value = "SysCollege对象", description = "学院表")
public class SysCollege extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "主键")
    private Long schoolId;

    @ApiModelProperty(value = "学校编码")
    private String code;

    @ApiModelProperty(value = "学校名称")
    private String name;

    @ApiModelProperty(value = "访问key")
    private String accessKey;

    @ApiModelProperty(value = "访问秘钥")
    private String accessSecret;

    public SysCollege() {

    }

    public SysCollege(Long id, Long schoolId, String code, String name, String accessKey, String accessSecret) {
        this.schoolId = schoolId;
        this.code = code;
        this.name = name;
        this.accessKey = accessKey;
        this.accessSecret = accessSecret;
        setId(id);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        SysCollege that = (SysCollege) o;
        return code.equals(that.code) && name.equals(that.name) && accessKey.equals(that.accessKey) && accessSecret.equals(that.accessSecret);
    }

    @Override
    public int hashCode() {
        return Objects.hash(code, name, accessKey, accessSecret);
    }

    public Long getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(Long schoolId) {
        this.schoolId = schoolId;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getAccessKey() {
        return accessKey;
    }

    public void setAccessKey(String accessKey) {
        this.accessKey = accessKey;
    }

    public String getAccessSecret() {
        return accessSecret;
    }

    public void setAccessSecret(String accessSecret) {
        this.accessSecret = accessSecret;
    }

}
