package com.qmth.eds.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qmth.eds.bean.dto.CloudMarkingScoreDto;
import com.qmth.eds.bean.dto.ExamSyncStudentDto;
import com.qmth.eds.bean.dto.ScoreDownloadDto;
import com.qmth.eds.bean.result.StudentMarkResult;
import com.qmth.eds.common.entity.CloudMarkingScore;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 云阅卷成绩表 Mapper 接口
 */
public interface CloudMarkingScoreMapper extends BaseMapper<CloudMarkingScore> {

    IPage<CloudMarkingScoreDto> pageData(@Param("page") Page<CloudMarkingScoreDto> page, @Param("collegeId") Long collegeId, @Param("semesterId") Long semesterId, @Param("examTypeId") Long examTypeId, @Param("examId") String examId);

    List<ExamSyncStudentDto> listExamSyncStudentDtos(@Param("schoolId") Long schoolId, @Param("semesterId") Long semesterId, @Param("examTypeId") Long examTypeId, @Param("courseCode") String courseCode, @Param("openCollege") String openCollege);

    /**
     * 查询学生成绩
     *
     * @param schoolId
     * @param collegeId
     * @param semesterId
     * @param examTypeId
     * @param openCollege
     * @param courseCode
     * @return
     */
    List<StudentMarkResult> queryStudentMark(@Param("schoolId") Long schoolId,
                                             @Param("collegeId") Long collegeId,
                                             @Param("semesterId") Long semesterId,
                                             @Param("examTypeId") Long examTypeId,
                                             @Param("openCollege") String openCollege,
                                             @Param("courseCode") String courseCode);

    List<ScoreDownloadDto> listScoreBySemesterIdAndExamTypeIdAndCollegeIdAndCourseCodeAndOpenCollege(@Param("semesterId") Long semesterId, @Param("examTypeId") Long examTypeId, @Param("collegeId") Long collegeId, @Param("courseCode") String courseCode, @Param("openCollege") String openCollege);
}
